﻿Imports System.Data.SqlClient
Imports System.Data.Common

Public Class clsEmployee

    Private adaptEmp As New SqlDataAdapter
    Private dstEmp As New DataSet
    Private connSTR As String

    'Advertisement

    Protected s_AdvertTitle As String
    Protected s_AdvertDetail As String

    'Media
    Protected s_Media As String

    'Location
    Protected s_CostCentre As String
    Protected s_BranchLocation As String

    'Client Info
    Protected s_Response As String

    'User & Updation of Data
    Protected s_UserName As String
    Protected s_UpdateDate As String


    ''************************************ User & Updation Details **************************************    
    Public Property UserName() As String
        Get
            Return s_UserName
        End Get
        Set(ByVal value As String)
            s_UserName = value
        End Set
    End Property

    Public Property UpdateDate() As String
        Get
            Return s_UpdateDate
        End Get
        Set(ByVal value As String)
            If Not String.IsNullOrEmpty(value) = True Then
                s_UpdateDate = value
            Else
                Throw New ArgumentException("Registered date field cannot be blank", "Check Registered Date")
            End If
        End Set
    End Property

    ''************************************ Advert Details **************************************    

    Public Property AdvertTitle() As String
        Get
            Return s_AdvertTitle
        End Get
        Set(ByVal value As String)
            s_AdvertTitle = value
        End Set
    End Property

    Public Property AdvertDetial() As String
        Get
            Return s_AdvertDetail
        End Get
        Set(ByVal value As String)
            s_AdvertDetail = value
        End Set
    End Property

    ''************************************ Media **************************************    
    Public Property Media() As String
        Get
            Return s_Media
        End Get
        Set(ByVal value As String)
            s_Media = value
        End Set
    End Property

    ''************************************ Location Details **************************************    
    Public Property CostCentre() As String
        Get
            Return s_CostCentre
        End Get
        Set(ByVal value As String)
            s_CostCentre = value
        End Set
    End Property

    Public Property BranchLocation() As String
        Get
            Return s_BranchLocation
        End Get
        Set(ByVal value As String)
            s_BranchLocation = value
        End Set
    End Property

    ''************************************ Client Details **************************************    

    Public Property Response() As String
        Get
            Return s_Response
        End Get
        Set(ByVal value As String)
            s_Response = value
        End Set
    End Property

    Sub New()
        connSTR = "Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=AdventureWorks;Data Source=DV-WORKSTATION"
    End Sub
    Public ReadOnly Property GetDataAsTable() As DataTable
        Get
            GetEmployee()
            Return dstEmp.Tables("tblAdvertInfo")
        End Get
    End Property

    Public ReadOnly Property GetDataAsTable(ByVal StrQuery As String) As DataTable
        Get
            GetEmployee(StrQuery)
            Return dstEmp.Tables("tblAdvertInfo")
        End Get
    End Property

    Private Sub GetEmployee()
        Dim cnnEmp As SqlConnection = New SqlConnection(connSTR)
        Try
            Dim selectCMD As SqlCommand = New SqlCommand("Select * From tblAdvertInfo", cnnEmp)
            selectCMD.CommandType = CommandType.Text

            cnnEmp.Open()

            dstEmp.Clear()
            adaptEmp.SelectCommand = selectCMD
            adaptEmp.Fill(dstEmp, "tblAdvertInfo")

            cnnEmp.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "TempID", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            If cnnEmp.State = ConnectionState.Open Then cnnEmp.Close()
        End Try
    End Sub

    Private Sub GetEmployee(ByVal StrQuery As String)
        Dim CnnEmp As SqlConnection = New SqlConnection(connSTR)
        Try
            Dim selectCMD As SqlCommand = New SqlCommand(StrQuery, CnnEmp)
            selectCMD.CommandType = CommandType.Text

            CnnEmp.Open()

            dstEmp.Clear()
            adaptEmp.SelectCommand = selectCMD
            adaptEmp.Fill(dstEmp, "tblAdvertInfo")

            CnnEmp.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "TempID", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            If CnnEmp.State = ConnectionState.Open Then CnnEmp.Close()
        End Try
    End Sub

    Public Sub SaveEmp()
        Dim cnnEmp As SqlConnection = New SqlConnection(connSTR)

        Try
            Dim strInsert As String

            strInsert = "Insert into tblAdvertInfo (" _
                        & "AdvertTitle," _
                        & "Media," _
                        & "AdvertDetail," _
                        & "CostCentre," _
                        & "UserName," _
                        & "UpdateDate," _
                        & "Response," _
                        & "BranchLocation) values ('" _
                        & s_AdvertTitle & "','" _
                        & s_Media & "','" _
                        & s_AdvertDetail & "','" _
                        & s_CostCentre & "','" _
                        & s_UserName & "','" _
                        & s_UpdateDate & "','" _
                        & s_Response & "','" _
                        & s_BranchLocation & "')"

            cnnEmp.Open()

            Dim selectCmd As SqlCommand
            selectCmd = New SqlCommand(strInsert, cnnEmp)
            selectCmd.CommandType = CommandType.Text

            selectCmd.ExecuteNonQuery()

        Catch ex As Exception
            MessageBox.Show(ex.Message, "TempID", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            If cnnEmp.State = ConnectionState.Open Then cnnEmp.Close()
            MessageBox.Show("New Advertisement has been Saved.....")
        End Try

    End Sub
End Class
